CATEGORY:=Administration
TITLE:=FFLuCI
SUBMENU:=FFLuCI
- DEPENDS:=+luaposix +haserl-lua +ffluci-system-addons
+ DEPENDS:=+luaposix +haserl-lua +ffluci-system-addons +ffluci-splash
MAINTAINER:=Steven Barth <steven-at-midlink-dot-org>
endef
$(CP) $(PKG_BUILD_DIR)/module/admin-core/dist/* $(1)/usr/lib/lua/ffluci/ -R
$(CP) $(PKG_BUILD_DIR)/module/admin-core/contrib/uci/luci_fw $(1)/etc/config/luci_fw
$(INSTALL_BIN) $(PKG_BUILD_DIR)/module/admin-core/contrib/init.d/luci_fw $(1)/etc/init.d/luci_fw
+ $(INSTALL_BIN) $(PKG_BUILD_DIR)/module/admin-core/contrib/init.d/luci_freifunk $(1)/etc/init.d/luci_freifunk
$(INSTALL_BIN) $(PKG_BUILD_DIR)/module/admin-core/contrib/ffluci-flash $(1)/sbin
$(INSTALL_BIN) $(PKG_BUILD_DIR)/module/admin-core/contrib/luci-splash $(1)/www/cgi-bin
option essid halle.freifunk.net
option bssid 02:CA:FF:EE:BA:BE
option realm netz.freifunk-halle.net
- option pool 104.62.0.0/16
\ No newline at end of file
+ option channel 1
+ option net 104.0.0.0
+ option mask 255.0.0.0
+ option dhcp 10.0.0.0
+ option dhcpmask 255.255.255.0
+ option dns "88.198.178.18 141.54.1.1 212.204.49.83 208.67.220.220 208.67.222.222"
+
+config settings routing
+ option internal 0
+ option internet 0
+
\ No newline at end of file
option fstab "/etc/init.d/fstab restart"
option qos "/etc/init.d/qos restart"
option luci_splash "/etc/init.d/luci_splash restart"
+ option freifunk "/etc/init.d/luci_freifunk restart"
config internal languages
option de "Deutsch"
<div class="cbi-map" id="cbi-<%=self.config%>">
<h1><%=self.title%></h1>
<div class="cbi-map-descr"><%=self.description%></div>
- <br />
<% self:render_children() %>
<br />
</div>
<div class="cbi-section" id="cbi-<%=self.config%>-<%=section%>">
<h2><%=self.title%></h2>
<div class="cbi-section-descr"><%=self.description%></div>
- <% if self.addremove then %><div class="cbi-section-remove">
+ <% if self.addremove then %><div class="cbi-section-remove right">
<input type="submit" name="cbi.rns.<%=self.config%>.<%=section%>" value="<%:cbi_del Eintrag entfernen%>" />
</div><% end %>
<%+cbi/ucisection%>
- <fieldset class="cbi-section-node" id="cbi-<%=self.config%>-<%=section%>">
+ <div class="cbi-section-node" id="cbi-<%=self.config%>-<%=section%>">
<% self:render_children(section) %>
<% if #self.optionals[section] > 0 or self.dynamic then %>
<div class="cbi-optionals">
<input type="submit" value="<%:add hinzufügen%>" />
</div>
<% end %>
- </fieldset>
+ </div>
<br />
\ No newline at end of file
- <div class="cbi-value-description inline"><%=self.description%></div>
+ <div class="cbi-value-description"><%=self.description%> </div>
</div>
<% if self.tag_invalid[section] then %><div class="cbi-error"><%:cbi_invalid Fehler: Ungültige Eingabe%></div><% end %>
</div>
- <div class="cbi-value clear" id="cbi-<%=self.config.."-"..section.."-"..self.option%>">
- <div class="cbi-value-title left"><%=self.title%></div>
+ <div class="cbi-value" id="cbi-<%=self.config.."-"..section.."-"..self.option%>">
+ <div class="cbi-value-title"><%=self.title%></div>
<div class="cbi-value-field">
\ No newline at end of file
--- /dev/null
+#!/bin/sh /etc/rc.common
+START=70
+
+start() {
+ include /lib/network
+ scan_interfaces
+
+
+ ### Read interface names
+ config_get wanif wan ifname
+ config_get lanif lan ifname
+ config_get ffif ff ifname
+
+
+ [ -n "$ffif" ] || return 0
+
+
+ ### Read from config
+ config_load freifunk
+
+ config_get_bool internal routing internal
+ [ -n "$wanif" ] && config_get_bool internet routing internal
+
+
+ ### Freifunk to Freifunk
+ [ "$internal" -gt 0 ] && {
+ iptables -A forwarding_rule -i "$ffif" -o "$ffif" -j ACCEPT
+ }
+
+ ### Lan to Freifunk
+ [ -n "$lanif" ] && {
+ iptables -A forwarding_rule -i "$lanif" -o "$ffif" -j ACCEPT
+ iptables -t nat -A postrouting_rule -i "$lanif" -o "$ffif" -j MASQUERADE
+ }
+
+ ### Freifunk to Wan
+ [ "$internet" -gt 0 ] && {
+ iptables -A forwarding_rule -i "$ffif" -o "$wanif" -j ACCEPT
+ iptables -t nat -A postrouting_rule -i "$ffif" -o "$wanif" -j MASQUERADE
+ }
+}
+
+stop() {
+ include /lib/network
+ scan_interfaces
+
+ ### Read interface names
+ config_get wanif wan ifname
+ config_get lanif lan ifname
+ config_get ffif ff ifname
+
+ [ -n "$ffif" ] || return 0
+
+ ### Freifunk to Freifunk
+ iptables -D forwarding_rule -i "$ffif" -o "$ffif" -j ACCEPT
+
+ ### Lan to Freifunk
+ [ -n "$lanif" ] && {
+ iptables -D forwarding_rule -i "$lanif" -o "$ffif" -j ACCEPT
+ iptables -t nat -D postrouting_rule -i "$lanif" -o "$ffif" -j MASQUERADE
+ }
+
+ ### Freifunk to Wan
+ [ -n "$wanif" -gt 0 ] && {
+ iptables -D forwarding_rule -i "$ffif" -o "$wanif" -j ACCEPT
+ iptables -t nat -D postrouting_rule -i "$ffif" -o "$wanif" -j MASQUERADE
+ }
+}
-module("ffluci.controller.admin.index", package.seeall)
\ No newline at end of file
+module("ffluci.controller.admin.index", package.seeall)
+
+function action_wizard()
+ if ffluci.http.formvalue("ip") then
+ return configure_freifunk()
+ end
+
+ local ifaces = {}
+ local wldevs = ffluci.model.uci.show("wireless")
+
+ if wldevs then
+ for k, v in pairs(wldevs.wireless) do
+ if v[".type"] == "wifi-device" then
+ table.insert(ifaces, k)
+ end
+ end
+ end
+
+ ffluci.template.render("admin_index/wizard", {ifaces=ifaces})
+end
+
+function configure_freifunk()
+ local ip = ffluci.http.formvalue("ip")
+ local uci = ffluci.model.uci.Session()
+
+ -- Configure FF-Interface
+ uci:del("network", "ff")
+ uci:del("network", "ffdhcp")
+
+ uci:set("network", "ff", nil, "interface")
+ uci:set("network", "ff", "type", "bridge")
+ uci:set("network", "ff", "proto", "static")
+ uci:set("network", "ff", "ipaddr", ip)
+ uci:set("network", "ff", "netmask", uci:get("freifunk", "community", "mask"))
+ uci:set("network", "ff", "dns", uci:get("freifunk", "community", "dns"))
+
+ -- Enable internal routing
+ uci:set("freifunk", "routing", "internal", "1")
+
+ -- Enable internet routing
+ if ffluci.http.formvalue("shareinet") then
+ uci:set("freifunk", "routing", "internet", "1")
+ else
+ uci:set("freifunk", "routing", "internet", "0")
+ end
+
+ -- Configure DHCP
+ if ffluci.http.formvalue("dhcp") then
+ local dhcpnet = uci:get("freifunk", "community", "dhcp"):match("^([0-9]+)")
+ local dhcpip = ip:gsub("^[0-9]+", dhcpnet)
+
+ uci:set("network", "ffdhcp", nil, "interface")
+ uci:set("network", "ffdhcp", "proto", "static")
+ uci:set("network", "ffdhcp", "ifname", "br-ff:dhcp")
+ uci:set("network", "ffdhcp", "ipaddr", dhcpip)
+ uci:set("network", "ffdhcp", "netmask", uci:get("freifunk", "community", "dhcpmask"))
+ end
+
+ -- Configure OLSR
+ if ffluci.http.formvalue("olsr") and uci:show("olsr") then
+ for k, v in pairs(uci:show("olsr").olsr) do
+ if v[".type"] == "Interface" or v[".type"] == "LoadPlugin" then
+ uci:del("olsr", "k")
+ end
+ end
+
+ if ffluci.http.formvalue("shareinet") then
+ uci:set("olsr", "dyn_gw", nil, "LoadPlugin")
+ uci:set("olsr", "dyn_gw", "Library", "olsrd_dyn_gw.so.0.4")
+ end
+
+ uci:set("olsr", "nameservice", nil, "LoadPlugin")
+ uci:set("olsr", "nameservice", "Library", "olsrd_nameservice.so.0.3")
+ uci:set("olsr", "nameservice", "name", ip:gsub("%.", "-"))
+ uci:set("olsr", "nameservice", "hosts_file", "/var/etc/hosts")
+ uci:set("olsr", "nameservice", "suffix", ".olsr")
+ uci:set("olsr", "nameservice", "latlon_infile", "/tmp/latlon.txt")
+
+ uci:set("olsr", "txtinfo", nil, "LoadPlugin")
+ uci:set("olsr", "txtinfo", "Library", "olsrd_txtinfo.so.0.1")
+ uci:set("olsr", "txtinfo", "Accept", "127.0.0.1")
+
+ local oif = uci:add("olsr", "Interface")
+ uci:set("olsr", oif, "Interface", "ff")
+ uci:set("olsr", oif, "HelloInterval", "6.0")
+ uci:set("olsr", oif, "HelloValidityTime", "108.0")
+ uci:set("olsr", oif, "TcInterval", "4.0")
+ uci:set("olsr", oif, "TcValidityTime", "324.0")
+ uci:set("olsr", oif, "MidInterval", "18.0")
+ uci:set("olsr", oif, "MidValidityTime", "324.0")
+ uci:set("olsr", oif, "HnaInterval", "18.0")
+ uci:set("olsr", oif, "HnaValidityTime", "108.0")
+ end
+
+ -- Configure Wifi
+ local wifi = ffluci.http.formvalue("wifi")
+ local wcfg = uci:show("wireless")
+ if type(wifi) == "table" and wcfg then
+ for iface, v in pairs(wifi) do
+ if wcfg[iface] then
+ -- Cleanup
+ for k, v in pairs(wcfg.wireless) do
+ if v[".type"] == "wifi-iface" and v.device == iface then
+ uci:del("wireless", k)
+ end
+ end
+
+ uci:set("wireless", iface, "disabled", "0")
+ uci:set("wireless", iface, "mode", "11g")
+ uci:set("wireless", iface, "txantenna", 1)
+ uci:set("wireless", iface, "rxantenna", 1)
+ uci:set("wireless", iface, "channel", uci:get("freifunk", "community", "channel"))
+
+ local wif = uci:add("wireless", "wifi-iface")
+ uci:set("wireless", wif, "device", iface)
+ uci:set("wireless", wif, "network", "ff")
+ uci:set("wireless", wif, "mode", "adhoc")
+ uci:set("wireless", wif, "ssid", uci:get("freifunk", "community", "essid"))
+ uci:set("wireless", wif, "bssid", uci:get("freifunk", "community", "bssid"))
+ uci:set("wireless", wif, "txpower", 13)
+ end
+ end
+ end
+
+
+ ffluci.http.request_redirect("admin", "uci", "changes")
+end
\ No newline at end of file
-- Todo: Translate
-m = Map("freifunk", "Freifunk", [[Informationen über die lokale Freifunkgemeinschaft.]])
+m = Map("freifunk", "Freifunk")
-c = m:section(NamedSection, "community", "public")
+s = m:section(NamedSection, "routing", "settings", "Netzverkehr")
+s:option(Flag, "internal", "Freifunk zulassen", "immer aktivieren!")
+s:option(Flag, "internet", "Internet zulassen")
+c = m:section(NamedSection, "community", "public", "Gemeinschaft", [[Dies sind die Grundeinstellungen
+für die lokale Freifunkgemeinschaft. Diese Werte wirken sich NICHT auf die Konfiguration
+des Routers aus, sondern definieren nur die Vorgaben für den Freifunkassistenten.]])
c:option(Value, "name", "Gemeinschaft")
c:option(Value, "homepage", "Webseite")
c:option(Value, "essid", "ESSID")
c:option(Value, "bssid", "BSSID")
+c:option(Value, "channel", "Funkkanal")
c:option(Value, "realm", "Realm")
-c:option(Value, "pool", "Adressbereich")
+c:option(Value, "net", "Adressbereich")
+c:option(Value, "mask", "Netzmaske")
+c:option(Value, "dns", "DNS-Server")
+c:option(Value, "dhcp", "DHCP-Bereich")
+c:option(Value, "dhcpmask", "DHCP-Maske")
return m
\ No newline at end of file
add("admin", "index", "Übersicht", 10)
+act("wizard", "Freifunkassistent")
act("contact", "Kontakt")
act("luci", "Oberfläche")
act("freifunk", "Freifunk")
--- /dev/null
+<%+header%>
+<h1><%:ffwizard Freifunkassistent%></h1>
+<p><%:ffwizard1 Dieser Assistent konfiguriert den Router für die Benutzung im Freifunknetz%></p>
+<br />
+<form method="post" action="<%=controller%>/admin/index/wizard">
+ <div class="cbi-section-node">
+ <div class="cbi-value">
+ <div class="cbi-value-title"><%:ip IP-Adresse%>:
+ <input type="text" size="20" name="ip" /></div>
+ </div>
+ <% for i, k in ipairs(ifaces) do %>
+ <div class="cbi-value">
+ <div class="cbi-value-title"><%:wificfg Drahtlosgerät einrichten%>: <%=k%></div>
+ <div class="cbi-value-field"><input type="checkbox" name="wifi.<%=k%>" value="1" checked="checked" /></div>
+ </div>
+ <% end %>
+ <div class="cbi-value">
+ <div class="cbi-value-title"><%:cfgolsr OLSR konfigurieren%></div>
+ <div class="cbi-value-field"><input type="checkbox" name="olsr" value="1" checked="checked" /></div>
+ </div>
+ <div class="cbi-value">
+ <div class="cbi-value-title"><%:cfgdhcp Drahtlos DHCP konfigurieren%></div>
+ <div class="cbi-value-field"><input type="checkbox" name="dhcp" value="1" checked="checked" /></div>
+ </div>
+ <div class="cbi-value">
+ <div class="cbi-value-title"><%:shareinet Internet teilen%></div>
+ <div class="cbi-value-field"><input type="checkbox" name="shareinet" value="1" checked="checked" /></div>
+ </div>
+ </div>
+ <br />
+ <div>
+ <input type="submit" value="<%:configure Konfigurieren%>" />
+ <input type="reset" value="<%:reset Zurücksetzen%>" />
+ </div>
+</form>
+<%+footer%>
\ No newline at end of file
<br />
<form method="post" action="<%=controller%>/admin/system/ipkg">
- <fieldset class="cbi-section-node">
+ <div class="cbi-section-node">
<div><textarea style="width: 100%" rows="10" name="data"><%=cnt%></textarea></div>
<br />
<div>
<input type="reset" value="<%:reset Zurücksetzen%>" />
</div>
<% if msg then %><br /><div class="error"><%:error Fehler%>: <%=msg%></div><% end %>
- </fieldset>
+ </div>
</form>
<%+footer%>
\ No newline at end of file
<% end %>
<% if not stat or stat == 10 then %>
<form method="post" action="<%=controller%>/admin/system/passwd">
- <fieldset class="cbi-section-node">
+ <div class="cbi-section-node">
<div class="cbi-value clear">
<div class="cbi-value-title left"><%:password Passwort%></div>
<div class="cbi-value-field"><input type="password" name="pwd1" /></div>
<input type="submit" value="<%:save Speichern%>" />
<input type="reset" value="<%:reset Zurücksetzen%>" />
</div>
- </fieldset>
+ </div>
</form>
<% end %>
</div>
<br />
<form method="post" action="<%=controller%>/admin/system/sshkeys">
- <fieldset class="cbi-section-node">
+ <div class="cbi-section-node">
<div><textarea style="width: 100%" rows="10" name="data"><%=cnt%></textarea></div>
<br />
<div>
<input type="reset" value="<%:reset Zurücksetzen%>" />
</div>
<% if msg then %><br /><div class="error"><%:error Fehler%>: <%=msg%></div><% end %>
- </fieldset>
+ </div>
</form>
<%+footer%>
\ No newline at end of file
<br />
<% if sysupgrade and not ret then %>
<form method="post" action="<%=controller%>-upload/admin/system/upgrade" enctype="multipart/form-data">
- <fieldset class="cbi-section-node">
+ <div class="cbi-section-node">
<div class="cbi-value clear">
<div class="cbi-value-title left"><%:fwimage Firmwareimage%></div>
<div class="cbi-value-field"><input type="file" size="30" name="image" /></div>
<div>
<input type="submit" value="<%:fwupgrade Firmware aktualisieren%>" />
</div>
- </fieldset>
+ </div>
</form>
<% elseif ret then %>
<% if ret == 0 then %>
text-align: right;
}
+.cbi-value {
+ display: table-row;
+}
+
.cbi-value-title {
+ display: table-cell;
line-height: 1.75em;
- width: 15em;
font-weight: bold;
+ padding: 0.25em;
}
.cbi-value-field {
+ display: table-cell;
text-align: left;
+ padding: 0.25em;
line-height: 1.75em;
}
}
.cbi-value-description {
+ display: inline;
font-style: italic;
font-size: 0.8em;
+ padding: 0.25em;
margin-bottom: 0.5em;
}
}
.cbi-section-node {
- display: block;
+ display: table;
+ padding: 0.25em;
background: #f7f7f7;
border: 1px solid #d7d7d7;
- overflow: auto;
- margn-bottom: 0%;
}
.cbi-section-node h3 {
}
for (var x in cbi_d[target]) {
- for (var i=0; i<cbi_d[target][x].length; i++) {
- document.getElementById(cbi_d[target][x][i]).style.display = "none";
+ for (var i=0; i<cbi_d[target][x].length; i++) {
+ var y = document.getElementById(cbi_d[target][x][i])
+ y.style.display = "none";
}
}
var t = document.getElementById(target);
if (t && t.value && cbi_d[target][t.value]) {
for (var i=0; i<cbi_d[target][t.value].length; i++) {
- document.getElementById(cbi_d[target][t.value][i]).style.display = "block";
+ var y = document.getElementById(cbi_d[target][t.value][i])
+ if (!y.value) {
+ y.style.display = "table-row";
+ } else {
+ y.style.display = "block";
+ }
}
}
}